// ------------------------ channel aux sends page ------------------------

function chauxPageCreate()
{
	var p={id:"chaux"};
	var f;
	var n, x;

// ch.options container frame
	p.frame=gui.newFrame(mainframe, 0, 0, 463, 507, '');
	p.frame.hide();
	f=p.frame;

	gui.newFrame(f, 150, 60, 145, 12, "img/channel_options.png");
	p.title={};
	p.title.frame=gui.newFrame(f, 174, 84, 100, 26, "img/chopt_title.png");
	p.title.label=gui.newLabel(p.title.frame, 5, 6, 90, 15, '', prop_channel);

	var aux_fr=gui.newFrame(f, 49, 131, 353, 169, "img/ch_edit_aux_bg.png");

	p.s=[];
	for(n=0; n<4; n++)
	{
		x=35+n*70;
		p.s[n]=
		{
			label: gui.newLabel(aux_fr, x, 118, 60, 14, '', prop_value),
			onoff: gui.newLabel(aux_fr, x,  55, 60, 14, '', prop_value),
			led:   gui.newPicture(aux_fr, x+26, 47, 7, 7, "img/led_7px.png"),
			val:   gui.newLabel(aux_fr, x,  75, 60, 14, '', prop_value),
			knob:  gui.newKnob (aux_fr, x+19, 92, 22, 22, "img/knob_22px.png"),
			v_on: false, v_post: false, v_gain: 0, v_angle: 0,
			tag_on:   host.sprintf("bAUX%d", n+1),
			tag_post: host.sprintf("bA%dPF", n+1),
			tag_gain: host.sprintf("wA%dGN", n+1),
			name: host.sprintf("SEND %c", 65+n), // 65 is an ASCII code for 'A'
			focus: function(on)
			{
				var prop=on?propAct:propOff;
				var idx=on?2:0;

				this.label.setProps(prop);
				this.onoff.setProps(prop);
				this.val.setProps(prop);
				this.knob.setIndex(idx);
			}
		};
		p.s[n].label.setText(p.s[n].name);
	}

	p.focus=-1;
	p.setFocus=function(newfocus)
	{
		if(newfocus==this.focus) return;
		if(this.focus in this.s) this.s[this.focus].focus(false);
		this.focus=newfocus;
		if(this.focus in this.s) this.s[this.focus].focus(true);
	}

// softknobs
	p.sknobs6=
	[
		{enabled: true, rot: "SEND A", push: "PRE/POST\nOFF"},
		{enabled: true, rot: "SEND B", push: "PRE/POST\nOFF"},
		{enabled: true, rot: "SEND C", push: "PRE/POST\nOFF"},
		{enabled: true, rot: "SEND D", push: "PRE/POST\nOFF"},
		{enabled: false},
		{enabled: false}
	];
	p.sknobs3=
	[
		{enabled: false, rot: "GAIN", push: "PRE/POST\nOFF", enter: true, updn: true, jog: true},
		{enabled: false}, // TODO: Mike's doc shows there should be a preview on Push
		{enabled: true, rot: "SELECT", push: "EXIT", ltrt: true}
	];

// event functions
	p.onOpen =chauxOnOpen;
	p.onClose=chauxOnClose;
	p.onIndi =chauxIndi;
	p.onSoftKnobRot =chauxOnSoftKnobRot;
	p.onSoftKnobDown=chauxOnSoftKnobDown;
	p.onSoftKnobUp  =chauxOnSoftKnobUp;

	pages.chaux=p;
}
function chauxOnOpen(channel_nr)
{
	var rmsg;

	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.setFocus(-1);
	sknobsSetOne(8, {angle: 180});
	sknobsSetOne(6, {angleNrm: 0});

	if(channel_nr!=null)
	{
		this.channel=channel_nr;
		this.title.label.setText(host.sprintf("CHANNEL %02d", channel_nr));

	// request aux data
		rmsg=host.sendChnCmsgRq(channel_nr, {id:"READ",
			bAUX1:0, bAUX2:0, bAUX3:0, bAUX4:0,
			bA1PF:0, bA2PF:0, bA3PF:0, bA4PF:0,
			bA1GN:0, bA2GN:0, bA3GN:0, bA4GN:0
		});
		if(rmsg!=null)
		{
			this.onIndi(rmsg);

		// register receive msg handlers
			pages.rxHandlersCh[this.channel].chaux=this;
			mod.setChnKeyLed(channel_nr, keys.ChnOptions, 255);
			mod.setMasterKeyLed(keys.MstChnAux, 255);
		}
	}
}
function chauxOnClose()
{
	sknobsHide();

// delete receive msg handlers
	delete pages.rxHandlersCh[this.channel].chaux;

	mod.setChnKeyLed(this.channel, keys.ChnOptions, 0);
	mod.setMasterKeyLed(keys.MstChnAux, 0);
}
function chauxIndi(chmsg)
{
	var n, snd, val, update;

	for(n=0; n<4; n++)
	{
		snd=this.s[n];
		update=false;
		if(snd.tag_gain in chmsg)
		{
			snd.v_gain=chmsg[snd.tag_gain];
			snd.v_angle=knobSetValue(snd, snd.v_gain, aux_const);
			sknobsSetOne(n, {angleNrm: snd.v_angle});
			if(this.focus==n)
				sknobsSetOne(6, {angleNrm: snd.v_angle});
		}
		if(snd.tag_on in chmsg)
		{
			snd.v_on=chmsg[snd.tag_on]==1;
			update=true;
		}
		if(snd.tag_post in chmsg)
		{
			snd.v_post=chmsg[snd.tag_post]==1;
			update=true;
		}
		if(update)
		{
			if(snd.v_on)
				val="ON "+(snd.v_post?"POST":"PRE");
			else
				val="OFF";
			snd.led.setIndex(snd.v_on?1:0);
			snd.onoff.setText(val);
		}
	}
}
function chauxOnSoftKnobRot(idx, delta)
{
	switch(idx)
	{
	case 1:
		chauxSetGain(this.channel, this.s[0], delta);
		break;
	case 2:
		chauxSetGain(this.channel, this.s[1], delta);
		break;
	case 3:
		chauxSetGain(this.channel, this.s[2], delta);
		break;
	case 4:
		chauxSetGain(this.channel, this.s[3], delta);
		break;
	case 7: // Combo1
		if(this.focus in this.s) chauxSetGain(this.channel, this.s[this.focus], delta);
		break;
	case 9: // Combo3
		this.setFocus(clamp(this.focus+delta, 0, 3));
		sknobsSetOne(8, {angleNrm: this.focus/3});
		var snd=this.s[this.focus];
		sknobsSetOne(6, {enabled: true, rot: snd.name, angleNrm: snd.v_angle});
		break;
	}
}
function chauxOnSoftKnobDown(idx)
{
	switch(idx)
	{
	case 1:
		chauxToggleOn(this.channel, this.s[0]);
		break;
	case 2:
		chauxToggleOn(this.channel, this.s[1]);
		break;
	case 3:
		chauxToggleOn(this.channel, this.s[2]);
		break;
	case 4:
		chauxToggleOn(this.channel, this.s[3]);
		break;
	case 7: // Combo1
		if(this.focus in this.s) chauxToggleOn(this.channel, this.s[this.focus]);
		break;
	}
}
function chauxOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 9: // Combo3
		chSwitchToPage(this); // will effectively go back to chopt page
		break;
	}
}

function chauxSetGain(chan, send, delta)
{
	var msg={id:'WRIN'};

	if(send.v_gain<=-400)
		delta*=30;
	else if(send.v_gain<=-200)
		delta*=20;
	else if(send.v_gain<=-100)
		delta*=10;
	else if(send.v_gain<= 110)
		delta*=5;

	msg[send.tag_gain]=clamp(send.v_gain+delta, aux_const.min, aux_const.max);
	host.sendChnCmsg(chan, msg);
}

/*
** chauxToggleOn
**
** change aux using following scheme:
** OFF -> ON PRE -> ON POST -> OFF
*/
function chauxToggleOn(chan, send)
{
	var msg={id:'WRIN'};

	if(!send.v_on)
	{
	// set ON PRE
		msg[send.tag_on]=1;
		msg[send.tag_post]=0;
	}
	else if(!send.v_post)
		msg[send.tag_post]=1;
	else
		msg[send.tag_on]=0;
	host.sendChnCmsg(chan, msg);
}
