// ------------------------ global returns page ------------------------

function returnsCreateObject(frame, x, y, title, tag)
{
	var obj={};

	obj.on   =gui.newPicture(frame, x+21, y   , 20, 20, "img/on_off.png");
	obj.knob =gui.newKnob   (frame, x+20, y+40, 22, 22, "img/knob_22px.png");
	obj.val  =gui.newLabel  (frame, x   , y+25, 60, 14, '', prop_value);
	obj.label=gui.newLabel  (frame, x+ 2, y+63, 60, 14, '', prop_value);
	obj.label.setText(title);
	obj.assgn=gui.newLabel  (frame, x+67, y+63, 60, 14, '', prop_value);
	obj.assgn.setText("ASSIGN");
	obj.pgmlst=gui.newList  (frame, x+67, y   , 50, 60, '', prop_list);
	obj.pgmlst.insert("PGM1", 0);
	obj.pgmlst.insert("PGM2", 1);
	obj.pgmlst.insert("PGM3", 2);
	obj.pgmlst.insert("PGM4", 3);
	obj.pgmlst.selection=0;

	obj.tag=tag;
	obj.preview=false;
	obj.onsw=false;
	obj.msgn=0;
	obj.pgm=[0,0,0,0];

	return obj;
}

function returnsPageCreate()
{
	var p={id:"returns"};
	var f;

// ch.options container frame
	p.frame=gui.newFrame(mainframe, 0, 0, 463, 507, '');
	p.frame.hide();
	f=p.frame;

	gui.newFrame(f, 150, 60, 144, 12, "img/monitor_options.png");
	p.title={};
	p.title.frame=gui.newFrame(f, 174, 84, 100, 26, "img/chopt_title.png");
	p.title.label=gui.newLabel(p.title.frame, 5, 6, 90, 15, '', prop_channel);
	p.title.label.setText("RETURNS");

	var aux_fr=gui.newFrame(f, 49, 298, 353, 169, "img/mst_returns_bg.png");

	p.returns=[];
	p.returns[0]=returnsCreateObject(aux_fr,  13, 37, "RETURN A", 'mRET1');
	p.returns[1]=returnsCreateObject(aux_fr, 163, 37, "RETURN B", 'mRET2');

// indicates which channel will be controlled with preview knob
	p.prv_select=0;
	p.preview=gui.newFrame(aux_fr, 15, 118, 60, 39, '');
	p.preview.line =gui.newPicture(p.preview, 29,  0,  2, 22, "img/line_vert.png");
	p.preview.label=gui.newLabel  (p.preview,  0, 24, 60, 14, '', prop_value);
	p.preview.label.setText("PREVIEW OFF");

	p.sknobs6=
	[
		{enabled: true, rot: "RETURN A", push: "OFF"},
		{enabled: true, rot: "ASSIGN",   push: "TAKE", list:p.returns[0].pgmlst},
		{enabled: true, rot: "RETURN B", push: "OFF"},
		{enabled: true, rot: "ASSIGN",   push: "TAKE", list:p.returns[1].pgmlst},
		{enabled: false},
		{enabled: true, rot: "SELECT",   push: "PREVIEW"}
	];

// event handling functions
	p.onOpen=function(channel_nr)
	{
		var rmsg, read_msg={id:"READ", bMSGN:0, bONSW:0, bPREV:0, bPGM1:0, bPGM2:0, bPGM3:0, bPGM4:0};

		sknobsShow(this.sknobs6);
		rmsg=host.sendCmsgRq({id:"NEST", mRET1:read_msg, mRET2:read_msg});
		if(rmsg!=null)
		{
			returnsIndi(rmsg);

		// register receive msg handlers
			pages.rxHandlersGlobal.returnsIndi=returnsIndi;
			mod.setMasterKeyLed(keys.MstSendRet, 255);
		}
	}
	p.onClose=function()
	{
	// turn preview off if it is ON
		if(this.returns[this.prv_select].preview) host.sendNestCmsg(this.returns[this.prv_select].tag, {id:'WRIN', bPREV:0});
		sknobsHide();
	// delete receive msg handlers
		delete pages.rxHandlersGlobal.returnsIndi;
		mod.setMasterKeyLed(keys.MstSendRet, 0);
	}
	p.onSoftKnobRot=function(idx, delta)
	{
		switch(idx)
		{
		case 1:
			sendsSetGain("mRET1", this.returns[0].msgn, delta)
			break;
		case 3:
			sendsSetGain("mRET2", this.returns[1].msgn, delta)
			break;
		case 6:
			if(delta==0) break;
			if(this.returns[this.prv_select].preview) break;	// Preview is on, don't allow to navigate from it
			this.prv_select=clamp(this.prv_select+(delta>0?1:-1), 0, 1);
			returnsSelectPre(this);
			break;
		}
	}
	p.onSoftKnobDown=function(idx)
	{
		var ind;

		switch(idx)
		{
		case 1:
		case 3:
			idx=(idx-1)/2;
			toggleVal(this.returns[idx].tag, 'bONSW', this.returns[idx].onsw);
			break;
		case 2:
		case 4:
			idx=(idx-2)/2;
			ind=this.returns[idx].pgmlst.selId;
			toggleVal(this.returns[idx].tag, "bPGM"+(ind+1), this.returns[idx].pgm[ind]);
			break;
		case 6:
			host.sendNestCmsg(this.returns[this.prv_select].tag, {id:'WRIN', bPREV:1});
			break;
		}
	}
	p.onSoftKnobUp=function(idx)
	{
		switch(idx)
		{
		case 6:
			host.sendNestCmsg(this.returns[this.prv_select].tag, {id:'WRIN', bPREV:0});
			break;
		}
	}

	pages.returns=p;
}
function returnsIndi(msg)
{
	var p=pages.returns;
	var n, obj;

	for(n=0; n<2; n++)
	{
		obj=p.returns[n];
		if(obj.tag in msg)
			returnsIndiEx(msg[obj.tag], p, obj, n*2);
	}
}
function returnsSetAssignment(bus_obj, pgm_idx, pgm_val)
{
		bus_obj.pgm[pgm_idx]=pgm_val;
		bus_obj.pgmlst.goPos(pgm_idx);
		bus_obj.pgmlst.icon =pgm_val;
		bus_obj.pgmlst.flags=pgm_val;
}
function returnsIndiEx(submsg, page, bus_obj, soft_knob_idx)
{
	var angl;

	if('wMSGN' in submsg)
	{
		bus_obj.msgn=submsg.wMSGN;
		angl=knobSetValue(bus_obj, bus_obj.msgn, aux_const);
		sknobsSetOne(soft_knob_idx, {angleNrm: angl});
	}
	if('bONSW' in submsg)
	{
		bus_obj.onsw=submsg.bONSW!=0;
		bus_obj.on.setIndex(bus_obj.onsw?1:0);
		sknobsSetOne(soft_knob_idx, {push: bus_obj.onsw?"ON":"OFF"});
	}
	if('bPREV' in submsg)
	{
		bus_obj.preview=submsg.bPREV!=0;
		returnsSelectPre(page);
	}
	if('bPGM1' in submsg) returnsSetAssignment(bus_obj, 0, submsg.bPGM1?1:0);
	if('bPGM2' in submsg) returnsSetAssignment(bus_obj, 1, submsg.bPGM2?1:0);
	if('bPGM3' in submsg) returnsSetAssignment(bus_obj, 2, submsg.bPGM3?1:0);
	if('bPGM4' in submsg) returnsSetAssignment(bus_obj, 3, submsg.bPGM4?1:0);
}
function returnsSelectPre(p)
{
	const xpos=[15,165];

	p.preview.moveTo(xpos[p.prv_select], 118);
	p.preview.label.setText(p.returns[p.prv_select].preview?"PREVIEW ON":"PREVIEW OFF");
	sknobsSetOne(5, {angleNrm:p.prv_select});
}
